import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;

/**
 * Write a description of class Button here.
 * 
 * @author (Busch2207) 
 * @version (Version 2.0)
 */
public class Button  extends Actor
{
    private GreenfootImage [] gi_arr_Image=new GreenfootImage[3];
    private int ButtonCall;
    private double FadeNumber,FadeSpeed;
    private boolean onThis=false,Fade=false,enabled=true;
    private List<Button.ButtonListener> list_buttonListener_=new ArrayList();

    /** creates a new Button, with the given images. Only the first three given images will be taken! (With less than 3 images, an image will be taken double) */
    public Button(GreenfootImage ... gi_arr_Images)
    {
        setImages(gi_arr_Images);
    }

    public void disable()
    {
        notOverCallListener();
        enabled=false;
    }

    public void enable()
    {
        enabled=true;
    }

    public void setImages(GreenfootImage ... gi_arr_Images)
    {
        if(gi_arr_Images.length==1 && gi_arr_Images[0]!=null)
        {
            if(gi_arr_Images[0]==gi_arr_Image[0])
                return;
            gi_arr_Images=createButtonImages(gi_arr_Images[0]);
        }
        if(gi_arr_Images.length>=3)
        {
            if(gi_arr_Images[0]==gi_arr_Image[0] && gi_arr_Images[1]==gi_arr_Image[1] && gi_arr_Images[2]==gi_arr_Image[2])
                return;
            gi_arr_Image[0]=gi_arr_Images[0];
            gi_arr_Image[1]=gi_arr_Images[1];
            gi_arr_Image[2]=gi_arr_Images[2];
        }
        else
        if(gi_arr_Images.length==2)
        {
            if(gi_arr_Images[0]==gi_arr_Image[0] && gi_arr_Images[1]==gi_arr_Image[1])
                return;
            gi_arr_Image[0]=gi_arr_Images[0];
            gi_arr_Image[1]=gi_arr_Images[1];
            gi_arr_Image[2]=new GreenfootImage(gi_arr_Images[1]);
        }
        else
        {
            gi_arr_Image[0]=getImage();
            gi_arr_Image[1]=new GreenfootImage(getImage());
            gi_arr_Image[2]=new GreenfootImage(getImage());
        }
        super.setImage(gi_arr_Image[0]);
    }

    /** creates an explanation, which will be shown, when the mouse moves over the button. (The created Explanation will be returned)*/
    public Button.Explanation addExplanation(String ... str_expla)
    {
        Button.Explanation expla_=new Button.Explanation(str_expla);
        addExplanation(expla_);
        return expla_;
    }

    /** creates an explanation, with the given colors, which will be shown, when the mouse moves over the button. (The created Explanation will be returned)*/
    public Button.Explanation addExplanation(Color col_String,Color col_Frame,Color col_Field,String ... str_expla)
    {
        Button.Explanation expla_=new Button.Explanation(col_String,col_Frame,col_Field,str_expla);
        addExplanation(expla_);
        return expla_;
    }

    /** adds an explanation, which will be shown, when the mouse moves over the button (The created ButtonListener will be returned) */
    public Button.ButtonListenerExplanation addExplanation(Button.Explanation expla_)
    {
        Button.ButtonListenerExplanation buttonListenerExpla_=new Button.ButtonListenerExplanation(expla_);
        addListener(buttonListenerExpla_);
        return buttonListenerExpla_;
    }

    /** adds a new button ButtonListener to perform different actions */
    public void addListener(Button.ButtonListener bl_)
    {
        list_buttonListener_.add(bl_);
    }

    /** removes the given Explanation */
    public void removeExplanation(Button.Explanation explanation_)
    {
        List<Button.ButtonListener> list_buttonListener_ToRemove=new ArrayList();
        for(Button.ButtonListener bl_:list_buttonListener_)
            if(bl_ instanceof Button.ButtonListenerExplanation && ((Button.ButtonListenerExplanation)bl_).explanation_==explanation_)
                list_buttonListener_ToRemove.add(bl_);
        for(Button.ButtonListener bl_:list_buttonListener_ToRemove)
            removeListener(bl_);
    }

    /** removes all Explanations */
    public void removeExplanations()
    {
        List<Button.ButtonListener> list_buttonListener_ToRemove=new ArrayList();
        for(Button.ButtonListener bl_:list_buttonListener_)
            if(bl_ instanceof Button.ButtonListenerExplanation)
                list_buttonListener_ToRemove.add(bl_);
        for(Button.ButtonListener bl_:list_buttonListener_ToRemove)
            removeListener(bl_);
    }

    /** removes the given ButtonListener */
    public void removeListener(Button.ButtonListener bl_)
    {
        list_buttonListener_.remove(bl_);
    }

    /** removes all ButtonListener (including explanations) */
    public void removeAllListener()
    {
        list_buttonListener_.clear();
    }

    private boolean mouseOnThis()
    {
        GreenfootImage i = getImage();
        MouseInfo mi_ = Greenfoot.getMouseInfo();
        if(mi_==null)
            return false;
        int
        w = i.getWidth(),
        h = i.getHeight(),
        mx= mi_.getX(),
        my= mi_.getY(),
        x = getX(),
        y = getY();
        mx-=x;
        my-=y;
        mx+=w/2-1;
        my+=h/2-1;
        return mx>=0 && mx<w && my>=0 && my<h && i.getColorAt(mx,my).getAlpha()>10; 
    }

    /** the act method */
    public void act()
    {
        try
        {
            doAct();
        }
        catch(Exception e)
        {}
    }

    private void doAct()
    {
        getImage().setTransparency(255);
        onThis=mouseOnThis();
        if(onThis)
        {
            if(getImage()!=gi_arr_Image[2])
                super.setImage(gi_arr_Image[1]);
            if(Greenfoot.mousePressed(null)||Greenfoot.mouseDragged(null))
                super.setImage(gi_arr_Image[2]);
        }
        else
            super.setImage(gi_arr_Image[0]);
        if(Greenfoot.mouseDragEnded(this))
        {
            if(onThis)
                super.setImage(gi_arr_Image[1]);
            else
                super.setImage(gi_arr_Image[0]);
        }
        if(onThis && Greenfoot.mouseClicked(null))
        {
            clickCallListener();
            super.setImage(gi_arr_Image[1]);
            if(Fade)
            {
                FadeNumber+=FadeSpeed;
                if(FadeNumber>=255)
                    FadeNumber=255;
                getImage().setTransparency((int)FadeNumber);
                if(FadeNumber>=255)
                    Fade=false;
            }
            return;
        }
        if(Fade)
        {
            FadeNumber+=FadeSpeed;
            if(FadeNumber>=255)
                FadeNumber=255;
            getImage().setTransparency((int)FadeNumber);
            if(FadeNumber>=255)
                Fade=false;
        }
        if(getImage()==gi_arr_Image[0])
            notOverCallListener();
        if(getImage()==gi_arr_Image[1])
            movedOverCallListener();
        if(getImage()==gi_arr_Image[2])
            draggedCallListener();
    }

    private void clickCallListener()
    {
        if(enabled)
            for(Button.ButtonListener bl_:list_buttonListener_)
                bl_.clicked(this);
    }

    private void notOverCallListener()
    {
        if(enabled)
            for(Button.ButtonListener bl_:list_buttonListener_)
                bl_.notOver(this);
    }

    private void movedOverCallListener()
    {
        if(enabled)
            for(Button.ButtonListener bl_:list_buttonListener_)
                bl_.movedOver(this);
    }

    private void draggedCallListener()
    {
        if(enabled)
            for(Button.ButtonListener bl_:list_buttonListener_)
                bl_.dragged(this);
    }

    /** let the button fade in (It will need the given frames) */
    public void fadeIn(int i_Frames)
    {
        Fade=true;
        FadeNumber=0;
        this.FadeSpeed=255./i_Frames;
        getImage().setTransparency((int)FadeNumber);
    }

    /** make line breakes in a long text for a better description */

    public static String[] createLineBreaks(int minLettersPerLine, int maxLettersPerLine,String... strings)
    {
        List<String> result = new LinkedList();
        for(String string:strings)
        {
            for(String toadd:createSingleLineBreaks(minLettersPerLine, maxLettersPerLine,string))
            {
                result.add(toadd);
            }
        }
        return result.toArray(new String[0]);
    }

    private static String[] createSingleLineBreaks(int minLetters, int maxLetters,String string)
    {
        List<String> result = new LinkedList();
        String line = "";
        String singleWords [] = string.split(" ");
        for(String word:singleWords)
        {
            if(line.length()>maxLetters)
            {
                result.add(line);
                line = "";
            }
            String fakeLine;
            if(line.isEmpty())
            {
                fakeLine = line+word;
            }
            else
            {
                fakeLine = line +" "+word;
            }
            if(line.length()>minLetters)
            {
                if(fakeLine.length()>maxLetters)
                {
                    result.add(line);
                    line = word;
                }
                else
                    line = fakeLine;
            }
            else
            {
                line = fakeLine;
            }
        }
        result.add(line);
        return result.toArray(new String[0]);
    }

    /** creates a brighter and a darker versions of the given image and returns them in an array, that they can be used to create a new button*/
    public static GreenfootImage[] createButtonImages(GreenfootImage gi_Image)
    {
        return new GreenfootImage[]
        {
            gi_Image,
            drawColorOverImage(new Color(255,255,255,50),gi_Image),
            drawColorOverImage(new Color(  0,  0,  0,50),gi_Image)
        };
    }

    private static GreenfootImage drawColorOverImage(Color Col,GreenfootImage i)
    {
        GreenfootImage i2 = new GreenfootImage(i);
        i=new GreenfootImage(i2);
        i.setColor(Col);
        i.fill();
        for(int x=0; x<i.getWidth(); x++)
            for(int y=0;y<i.getHeight();y++)
            {
                Color
                C2 = i2.getColorAt(x,y),
                C  = i.getColorAt(x,y);
                i2.setColorAt(x,y, new Color(C.getRed(),C.getGreen(),C.getBlue(),C2.getAlpha()));
            }
        return i2;
    }

    public interface ButtonListener  
    {
        void clicked(Button button_);

        void notOver(Button button_);

        void movedOver(Button button_);

        void dragged(Button button_);
    }

    private class ButtonListenerExplanation implements Button.ButtonListener
    {
        private Button.Explanation explanation_;

        public ButtonListenerExplanation(Button.Explanation ex_)
        {
            this.explanation_=ex_;
        }

        public void clicked(Button b)
        {}

        public void dragged(Button b)
        {}

        public void notOver(Button b)
        {
            if(explanation_.getWorld()==null)
                return;
            explanation_.getWorld().removeObject(explanation_);
        }

        public void movedOver(Button b)
        {
            if(explanation_.getWorld()!=null)
                return;
            MouseInfo mi_=Greenfoot.getMouseInfo();
            if(mi_!=null)
            {
                explanation_.bind(b);
                getWorld().addObject(explanation_,
                    Math.max(explanation_.getWidth()/2,Math.min(mi_.getX()+explanation_.getWidth()/2,getWorld().getWidth()-explanation_.getWidth()/2)),
                    Math.max(explanation_.getHeight()/2,Math.min(mi_.getY()+explanation_.getHeight()/2,getWorld().getHeight()-explanation_.getHeight()/2)));
            }
        }
    }

    public class Explanation extends Actor
    {
        private Button bounded;
        private Color stringCol;
        private Color frameCol;
        private Color fieldCol;
        public Explanation(String ... str_arr_Text)
        {
            this(Color.WHITE,Color.BLACK,new Color(50,50,50,200),str_arr_Text);
        }

        public Explanation(Color col_String,Color col_Frame,Color col_Field,String... str_arr_Text)
        {
            stringCol = col_String;
            frameCol = col_Frame;
            fieldCol = col_Field;
            setText(str_arr_Text);
        }

        public void setText(String... str_arr_Text)
        {
            Color col_String = stringCol;
            Color col_Frame = frameCol;
            Color col_Field = fieldCol;
            GreenfootImage [] gi_arr_=new GreenfootImage[str_arr_Text.length];
            int height=2,width=0;
            for(int i=0;i<str_arr_Text.length;i++)
            {
                gi_arr_[i]=new GreenfootImage(str_arr_Text[i],20,col_String,new Color(0,0,0,0));
                height+=gi_arr_[i].getHeight();
                width=Math.max(gi_arr_[i].getWidth(),width);
            }
            width+=2;
            GreenfootImage gi_My=new GreenfootImage(width,height);
            gi_My.setColor(col_Field);
            gi_My.fill();
            gi_My.setColor(col_Frame);
            gi_My.drawRect(0,0,width-1,height-1);
            height=1;
            for(int i=0;i<gi_arr_.length;i++)
            {
                gi_My.drawImage(gi_arr_[i],1,height);
                height+=gi_arr_[i].getHeight();
            }
            super.setImage(gi_My);
        }

        private void bind(Button bind)
        {
            this.bounded=bind;
        }

        public void act()
        {
            if(bounded.getWorld()==null)
                getWorld().removeObject(this);
        }

        private int getHeight()
        {
            return getImage().getHeight();
        }

        private int getWidth()
        {
            return getImage().getWidth();
        }
    }
}